import type { Task } from './types';
export interface TaskQueue {
    readonly size: number;
    shift(): Task | null;
    remove(task: Task): void;
    push(task: Task): void;
}
export declare class ArrayTaskQueue implements TaskQueue {
    tasks: Task[];
    get size(): number;
    shift(): Task | null;
    push(task: Task): void;
    remove(task: Task): void;
}
/**
 * Verifies if a given TaskQueue is valid
 *
 * @export
 * @param {*} value
 * @return {*}  {boolean}
 */
export declare function isTaskQueue(value: TaskQueue): boolean;
